package d10;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Scanner;

/**
 * Lukee tiedoston ja laskee kuinka monta mitäkin kirjainta oli tiedossa.
 * Isot ja pienet kirjaimet ovat tulkitaan samoiksi
 */
public class TehtavaT3 {
    private static int ENSIMMAINEN_ASCII_NUMERO = 97; // a = 97
    private static int VIIMEINEN_ASCII_NUMERO = 122; // z = 122
    /**
     *
     * @param args ensimmäine argumentti on luettava tiedoston nimi.
     */
    public static void main(String[] args) {
        if (args.length == 0) {
            System.out.println("Anna tiedoston nimi argumenttina");
            return;
        }
        String tiedosto = args[0];
        int[] luvut = new int[VIIMEINEN_ASCII_NUMERO + 1];
        try (Scanner s = new Scanner(new FileInputStream(new File(tiedosto)))) {
            while (s.hasNext()) {
                String line = s.nextLine().toLowerCase();
                for (int i = 0; i < line.length(); i++) {
                    int paikka = line.charAt(i);
                    luvut[paikka] += 1;
                }
            }
        } catch (IOException e) {
            System.out.println("Virhe luettaessa tiedostoa.");
        }
        // Lopuksi tulostetaan tulokset
        for (int i = ENSIMMAINEN_ASCII_NUMERO; i < luvut.length; i++) {
            char c = (char) i;
            System.out.println(c + " : " + luvut[i]);
        }
    }
}
