package d3;

import java.util.Scanner;

public class Tehtava8 {
    public static void main(String[] args) {
        System.out.println("Järjestän syötteen kaksi ensimmäistä sanaa aakkosjärjestykseen ja tulostan ne");
        System.out.println("Esimerkiksi 'Kamelin kyttyrässä on likaa' -> 'Kamelin kyttyrässä'");
        System.out.println("Esimerkiksi 'murmelin jalat' -> 'jalat murmelin'");
        System.out.print("Anna merkkijono> ");
        Scanner sc = new Scanner(System.in);
        String merkkijono = sc.nextLine();

        System.out.println("Sanat järjestyksessä " + jarjesta1ja2(merkkijono));
    }

    /**
     * @param merkkijono Merkkijono
     * @return Merkkijonon kaksi ensimmäistä sanaa aakkosjärjestyksessä. Jos merkkijono lyhyempi kuin kaksi sanaa,
     * palauttaa sellaisenaan. Jos sanat ovat osittain samat, lyhyempi sana asetetaan ensimmäiseksi.
     * @example <pre name="test">
     * jarjesta1ja2("paljon merkkejä") === "merkkejä paljon"
     * jarjesta1ja2("testi") === "testi"
     * jarjesta1ja2("aku ankan veljenpojat") === "aku ankan"
     * jarjesta1ja2("lentokoneenkuljettaja lentokone") === "lentokone lentokoneenkuljettaja"
     * </pre>
     */
    public static String jarjesta1ja2(String merkkijono) {
        String[] lista = merkkijono.split(" ");
        if (lista.length < 2) {
            return merkkijono;
        }
        StringBuilder tulos = new StringBuilder();
        String ensimmainen = lista[0].toLowerCase();
        String toinen = lista[1].toLowerCase();
        int silmukanKierrokset = Math.min(ensimmainen.length(), toinen.length());
        for (int i = 0; i < silmukanKierrokset; i++) {
            char c = ensimmainen.charAt(i);
            char c2 = toinen.charAt(i);
            if (c < c2) {
                tulos.append(ensimmainen);
                tulos.append(" ");
                tulos.append(toinen);
                break;
            } else if (c2 < c) {
                tulos.append(toinen);
                tulos.append(" ");
                tulos.append(ensimmainen);
                break;
            }
        }
        /* Jos silmukassa ei todettu eroavaisuuksia, verrataan sanojen pituuksia. Lyhyempi tulee ensin */
        if (tulos.isEmpty()) {
            if (ensimmainen.length() > toinen.length()) {
                tulos.append(toinen);
                tulos.append(" ");
                tulos.append(ensimmainen);
            } else {
                tulos.append(ensimmainen);
                tulos.append(" ");
                tulos.append(toinen);
            }
        }
        return tulos.toString();
    }
}
