package d5;

/**
 * Luokka luo otuksen, joka mallintaa tietokonetta.
 */
public class Tietokone {
    private int muisti, tallennustila;
    private String naytonohjain, prosessori;
    private boolean paalla;


    public Tietokone() {
        muisti = 0;
        tallennustila = 0;
        naytonohjain = "";
        prosessori = "";
        paalla = false;
    }

    public Tietokone(int muisti, int tallennustila, String naytonohjain, String prosessori) {
        this.muisti = muisti;
        this.tallennustila = tallennustila;
        this.naytonohjain = naytonohjain;
        this.prosessori = prosessori;
    }

    public int getMuisti() {
        return muisti;
    }
    public int getTallennustila() {
        return tallennustila;
    }
    public String getNaytonohjain() {
        return naytonohjain;
    }
    public String getProsessori() {
        return prosessori;
    }
    public void käynnistä() {
        if (this.paalla) {
            System.out.println("Tietokone on jo käynnissä.");
        } else {
            this.paalla = true;
        }
    }
    public void sammuta() {
        if (!this.paalla) {
            System.out.println("Tietokone on jo sammuksissa.");
        } else {
            this.paalla = false;
        }
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("Tietokone on ");
        sb.append(paalla ? "käynnissä" : "sammuksissa");
        sb.append("\n");
        sb.append("Muisti: " + muisti + " Gb");
        sb.append("\n");
        sb.append("Tallennustila: " + tallennustila + " Gb");
        sb.append("\n");
        sb.append("Naytonohjain: " + naytonohjain);
        sb.append("\n");
        sb.append("Prosessori: " + prosessori);
        return sb.toString();
    }

    public static void main(String[] args) {
        Tietokone t = new Tietokone(16,512,"RTX5070", "AMD Ryzen 3070");
        System.out.println(t);
    }
}
