package d6;

/**
 * Laiva luokka perii kulkuneuvon
 * @author jokayli
 * @version 23.2.2025
 */
public class Laiva extends Kulkuneuvo {
    public int pelastusVeneet, pelastusVeneenMatkustajat;
    public boolean evakoitu = false;

    /**
     *
     * @param nopeus nopeus
     * @param matkustajat matkustajien määrä
     * @param pelastusVeneet pelastusveneiden määrä
     * @param pelastusVeneenMatkustajat kuinka monta matkustajaa per vene
     */
    public Laiva(int nopeus, int matkustajat, int pelastusVeneet, int pelastusVeneenMatkustajat) {
        super(nopeus, matkustajat);
        this.pelastusVeneet = pelastusVeneet;
        this.pelastusVeneenMatkustajat = pelastusVeneenMatkustajat;
    }

    /**
     * Evakuoi aluksen ja tulostaa kuinta monta saadaan pelastettua
     */
    public void evakuoi() {
        int pelastetut = pelasta();
        if (pelastetut >= 0) {
            System.out.println("Kaikki matkustajat pelastettu");
        } else {
            System.out.println((pelastetut * -1) + " matkustajaa jäi pelastamatta");
        }
        this.evakoitu = true;
    }

    /**
     * Palauttaa kuinka monta paikkaa on pelastuveneissä ylimääräistä
     * @return jos positiivinen, saadaan kaikki pelastettua, jos negaativinen, jää osa rannalle
     */
    public int pelasta() {
        return (pelastusVeneet * pelastusVeneenMatkustajat) - matkustajat;
    }

    public static void main(String[] args) {
        Laiva laiva = new Laiva(10, 500, 10, 10);
        if (laiva.pelasta() == 100) {
            System.out.println("Voidaan pelastaa 100 matkustajaa");
        }
        laiva.evakuoi(); //400 matkustajaa jäi pelastamatta
    }
}
