package d6;

import fi.jyu.mit.graphics.*;

import java.awt.*;

public class SaannollinenMonikulmio extends BasicShape {
    private final RPoint center;
    private int sivut;
    private int resolution;
    private int[] sXPoints;
    private int[] sYPoints;

    /**
     * Luo uuden monikulmion
     *
     * @param x     monikulmion keskipisteen x-koordinaatti
     * @param y     monikulmion keskipisteen y-koordinaatti
     * @param z     monikulmion keskipisteen z-koordinaatti
     * @param sivut sivujen määrä
     */

    public SaannollinenMonikulmio(double x, double y, double z, int sivut) {
        super();
        this.center = new RPoint(x, y, z);
        this.sivut = sivut;
        initialize();

    }

    /**
     * Alustaa ympyrn asetukset
     */
    private void initialize() {
        this.sXPoints = new int[sivut];
        this.sYPoints = new int[sivut];
    }


    public static void main(String[] args) {
        EasyWindow window = new EasyWindow();
        window.add(new SaannollinenMonikulmio(50, 50, 30, 3));
        //window.add(new SaannollinenMonikulmio(150, 50, 30, 4));
        //window.add(new SaannollinenMonikulmio(50, 150, 30, 5));
        //window.add(new SaannollinenMonikulmio(150, 150, 30, 6));
        window.showWindow();
    }

    /**
     * Piirretään monikulmio
     *
     * @see fi.jyu.mit.graphics.BasicShape#drawShape(java.awt.Graphics, fi.jyu.mit.graphics.Matrix)
     */
    @Override
    protected void drawShape(Graphics g, Matrix a) {
        Vector rp = new Vector();
        SPoint sp = new SPoint(0, 0);
        for (int i = 0; i < this.sivut; i++) {
            a.transform(
                    100 * i * -sivut * 50
                            + this.center.getX(),
                    100 * i * sivut * 50
                            + this.center.getY(),
                    this.center.getZ(), rp, sp);
            sXPoints[i] = sp.getX();
            sYPoints[i] = sp.getY();
        }
        g.drawPolygon(sXPoints, sYPoints, sivut);
    }

}
