package d6.perinta;

import d6.rajapinta.ElainRajapinta;

/**
 * Kissa joka toteutaa ElainRajapintaa
 * @author jokayli
 * @version 23.2.2025
 * @example
 * <pre name="test">
 *   Kissa k = new Kissa("Miukumauku",2300);
 *   k.tulosta(); // tulostaa  "Miukumauku 2300.0";
 * </pre>
 */
public class Kissa implements ElainRajapinta { // kissa on elain  cat is a animal
    private String nimi;
    private double paino;

    /**
     * Alustetaan kissan nimi ja paino
     * @param nimi kissan nimi
     * @param paino kissan paino
     */
    public Kissa(String nimi, double paino) {
        this.nimi = nimi;
        this.paino = paino;
    }


    /**
     * Äännellään kuten kissa
     */
    @Override
    public void aantele() {
        System.out.println("Miuaaa");
    }

    /**
     * Tulostaa kissan muodossa "nimi paino"
     */
    @Override
    public void tulosta() {
        System.out.println(nimi + " " + paino);
    }


    /**
     * Testataan Kissa-luokkaa
     * @param args ei käytössä
     */
    public static void main(String[] args) {

        Kissa miuku = new Kissa("Miuku", 18000);
        miuku.aantele();
        miuku.tulosta();
        Kissa mirri = new Kissa("Mirri", 930);
        mirri.aantele();
        mirri.tulosta();
    }

}
