package d6.perinta;

import d6.rajapinta.ElainRajapinta;

/**
 * Koira joka toteutaa ElainRajapintaa
 * @author jokayli
 * @version 23.2.2025
 * @example
 * <pre name="test">
 *   Koira k = new Koira("Musti",2300);
 *   k.tulosta(); //tulosta  "Musti 2300.0";
 * </pre>
 */
public class Koira implements ElainRajapinta {
    private String nimi;
    private double paino;
    /**
     * Alustetaan koiran tiedot
     * @param nimi koiran nimi
     * @param paino koiran paino
     */
    public Koira(String nimi, double paino) {
        this.nimi = nimi;
        this.paino = paino;
    }


    /**
     * Ääntelee kuin koira
     */
    @Override
    public void aantele() {
        System.out.println("Hau hau");
    }

    /**
     * Tulostaa koiran muodossa "nimi paino"
     */
    @Override
    public void tulosta() {
        System.out.println(nimi + " " + paino);
    }


    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        ElainRajapinta elukat[] = {
                new Koira("Musti", 18005),
                new Kissa("Mirri", 18000),
                new Koira("Pluto", 1930),
                new Kissa("Miuku", 980),
                new Kotka("Kalle", 2400)
        };

        for (int i = 0; i < elukat.length; i++) {
            elukat[i].aantele();
            elukat[i].tulosta();
        }

    }
}