package d6.perinta;

import d6.rajapinta.ElainRajapinta;

/**
 * Kotka joka toteutaa ElainRajapintaa
 * @author jokayli
 * @version 23.2.2025
 * @example
 * <pre name="test">
 *   Kotka k = new Kotka("Kotka",2300);
 *   k.tulosta(); // tulostaa "Kotka 2300.0";
 * </pre>
 */
public class Kotka implements ElainRajapinta {
    private String nimi;
    private int paino;

    public Kotka(String nimi, int paino) {
        this.nimi = nimi;
        this.paino = paino;
    }

    /**
     * Ääntelee kuin kotka
     */
    @Override
    public void aantele() {
        System.out.println("kraahkraah");
    }

    /**
     * Tulostaa kotkan muodossa "nimi paino"
     */
    @Override
    public void tulosta() {
        System.out.println(nimi + " " + paino);
    }
}
