package d7;

public class TehtavaT1 {

    /**
     * Tarkistaa onko jonossa kaikki annetut merkit
     *
     * @param jono   merkkijono
     * @param merkit kirjain tai merkkijono, jota verrataan jonoon..
     * @return true jos jonossa samat merkit kuin merkit parametrissä
     * @example <pre name="test">
     * onkoMuita("kissa", "aik") === true
     * onkoMuita("kissa", "aiks") === false
     * </pre>
     */
    public static boolean onkoMuita(String jono, String merkit) {
        for (char c : merkit.toCharArray()) {
            jono = jono.replaceAll(String.valueOf(c), "");
        }
        return !jono.isEmpty();
    }

    /**
     * Tarkistaa löytyy annettu merkki jonosta
     *
     * @param jono   Merkkijono
     * @param merkki merkki tai merkkijono, jota verrataan jonosta
     * @return true jos merkki löytyy
     * @example <pre name="test">
     * onkoJoku("kissa", "k") === true
     * onkoJoku("kissa", "e") === false
     * onkoJoku("kissa", "ek") === true
     * </pre>
     */
    public static boolean onkoJoku(String jono, String merkki) {
        for (char c : merkki.toCharArray()) {
            if (jono.contains(String.valueOf(c))) {
                return true;
            }
        }
        return false;
    }

    public static void main(String[] args) {
        String jono = "kissa";
        String k = "aik";
        // TODO: kohta 1
        if (onkoMuita(jono, k)) System.out.println("on muitakin kuin " + k);
        //
        String polku = "C:\\mytemp\\ohj2\\vesal\\Koe.java";
        // TODO: kohta 2
        int i = polku.lastIndexOf("\\");
        System.out.println(polku.substring(i));
        //
        // TODO: kohta 3
        k = "ibm";
        if (onkoJoku(jono, k)) System.out.println("on joku " + k);
        k = "pc";
        if (onkoJoku(jono, k)) System.out.println("on joku " + k);
    }
}
