package d8;

import java.util.Calendar;

/**
 * Päiväys koneesta.
 * @author Joonas Yli-Saari
 */
public class Pvm {

    private int pv;
    private int kk;
    private int vv;

    private Pvm(int pv, int kk, int vv) {
        this.pv = pv;
        this.kk = kk;
        this.vv = vv;
    }


    /**
     * @return nykyhetkeä vastaava päivämäärä
     *
     * @example <pre name="test">
     * Pvm p = Pvm.getInstance();
     * p.toString() === "10.3.2025"
     * </pre>
     */
    public static Pvm getInstance() {
        Calendar calendar = Calendar.getInstance();
        return new Pvm(calendar.get(Calendar.DAY_OF_MONTH), calendar.get(Calendar.MONTH) + 1, calendar.get(Calendar.YEAR));
    }


    /**
     * Päivämäärä merkkijonona
     * @return päivämäärä muodossa 17.2.2007
     */
    @Override
    public String toString() {
        return pv + "." + kk + "." + vv;
    }


    /**
     * Testataan Pvm-luokkaa
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Pvm tanaan = Pvm.getInstance();
        System.out.println(tanaan);
    }
}