package d8;

public class TehtavaT3 {
    public static void main(String[] args) {
        double rahani = 2.4;
        System.out.println("Voin ostaa " + suurinKirjeenPaino(rahani) + "grammaa painavan kirjeen.");
    }

    /**
     * Palauttaa suurimman kirjeen jonka rahalla saa
     *
     * @example <pre name="test">
     * suurinKirjeenPaino(5.00) === 500
     * suurinKirjeenPaino(11.00) === 2000
     * suurinKirjeenPaino(7.00) === 1000
     * suurinKirjeenPaino(1.00) === 50
     * suurinKirjeenPaino(1.39) === 50
     * suurinKirjeenPaino(1.40) === 100
     * </pre>
     */
    public static int suurinKirjeenPaino(double raha) {
        Hinta[] hinnat = new Hinta[6];
        hinnat[0] = new Hinta(1.00, 50);
        hinnat[1] = new Hinta(1.40, 100);
        hinnat[2] = new Hinta(2.00, 250);
        hinnat[3] = new Hinta(4.00, 500);
        hinnat[4] = new Hinta(6.00, 1000);
        hinnat[5] = new Hinta(10.00, 2000);
        int indeksi = 0;
        for (int i = 0; i < hinnat.length; i++) {
            if (hinnat[i].getHinta() <= raha) {
                indeksi = i;
            }
        }
        return hinnat[indeksi].getPaino();
    }

    /**
     * Palauttaa suurimman kirjeen jonka rahalla saa
     *
     * @example <pre name="test">
     * suurinKirjeenPainoMatriisilla(5.00) === 500
     * suurinKirjeenPainoMatriisilla(11.00) === 2000
     * suurinKirjeenPainoMatriisilla(7.00) === 1000
     * suurinKirjeenPainoMatriisilla(1.00) === 50
     * suurinKirjeenPainoMatriisilla(1.39) === 50
     * suurinKirjeenPainoMatriisilla(1.40) === 100
     * </pre>
     */
    public static int suurinKirjeenPainoMatriisilla(double raha) {
        double[][] rahat = {{1.00, 50}, {1.40, 100}, {2.00, 250}, {4.00, 500}, {6.00, 1000}, {10.00, 2000}};
        int indeksi = 0;
        for (int i = 0; i < rahat.length; i++) {
            if (rahat[i][0] <= raha) {
                indeksi = i;
            }
        }
        return (int) rahat[indeksi][1];
    }

    public static class Hinta{
        private double hinta;
        private int paino;
        public Hinta(double hinta, int paino) {
            this.hinta = hinta;
            this.paino = paino;
        }
        public double getHinta() {
            return hinta;
        }
        public int getPaino() {
            return paino;
        }
    }
}
