package fxPadelRekisteri;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.TextAreaOutputStream;
import javafx.event.Event;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.TextArea;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.BorderPane;
import javafx.scene.text.Font;
import padelRekisteri.Halli;
import padelRekisteri.Tulos;

import java.io.PrintStream;
import java.net.URL;
import java.util.ResourceBundle;

public class HallitController extends ViewChangeHandler implements Initializable {

    @FXML
    private BorderPane panelHalli;
    @FXML
    private ListChooser<Halli> chooserHallit;


    private Halli valittuHalli;
    private TextArea areaHalli = new TextArea();

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        alusta();
    }

    @FXML
    void handleUusiHalli(MouseEvent event) {

        UusiHalliController.avaaUusiHalli();
        if (true) {
            Halli halli = new Halli();
            halli.asetaTestiArvot();
            PadelRekisteriMain.controller.getKayttaja().lisaaHalli(halli);
            hae(halli.getId());
        }
    }


    @FXML
    void handleTallenna(MouseEvent event) {
        Dialogs.showMessageDialog("Hallin muutoksia ei osata tallentaa");
    }

    @FXML
    void handleJarjesta(Event event) {
        Dialogs.showMessageDialog("Halleja ei osata jarjestaa vielä");
    }

    /**
     * Tekee tarvittavat muut alustukset, nyt vaihdetaan GridPanen tilalle
     * yksi iso tekstikenttä, johon voidaan tulostaa jäsenten tiedot.
     * Alustetaan myös jäsenlistan kuuntelija
     */
    protected void alusta() {
        panelHalli.setCenter(areaHalli);
        areaHalli.setFont(new Font("Courier New", 12));

        chooserHallit.clear();
        chooserHallit.addSelectionListener(e -> naytaHalli());
        haeHallit();
    }

    /**
     * Näyttää valitun hallin tiedot
     */
    protected void naytaHalli() {
        valittuHalli = chooserHallit.getSelectedObject();
        if (valittuHalli == null) return;

        areaHalli.setText("");
        try (PrintStream os = TextAreaOutputStream.getTextPrintStream(areaHalli)) {
            valittuHalli.tulosta(os);
        }
    }

    protected void haeHallit() {
        PadelRekisteriMain.controller.getKayttaja().getHallit().iterator().forEachRemaining(halli -> {
            chooserHallit.add(halli.getNimi(), halli);
        });
    }

    /**
     * Hakee jäsenten tiedot listaan
     */
    protected void hae(int id) {
        chooserHallit.clear();
        int index = 0;
        for (int i = 0; i < PadelRekisteriMain.controller.getKayttaja().getHallit().getHallit().size(); i++) {
            Halli h = PadelRekisteriMain.controller.getKayttaja().getHallit().annaHalli(i);
            if (h != null) {
                if (h.getId() == id) {
                    index = i;
                }
                chooserHallit.add(h.getNimi(), h);
            }
        }
        chooserHallit.setSelectedIndex(index); // tästä tulee muutosviesti joka näyttää jäsenen
    }

}
