package fxPadelRekisteri;

import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.fxml.FXML;
import javafx.scene.control.TextField;
import javafx.stage.Stage;

public class LoginController implements ModalControllerInterface<String> {

    @FXML private TextField textEmail;
    private String email = null;

    @FXML private void handleLogin() {
        email = textEmail.getText();
        ModalController.closeStage(textEmail);
    }

    @FXML private void handleCreateNewAccount() {
        UusiUserController.avaa(ModalController.getStage(textEmail));
    }

    @FXML private void handleCancel() {
        ModalController.closeStage(textEmail);
    }


    /**
     * Luodan nimenkysymisdialog ja palautetaan kirjoitettu nimi tai null
     * @param modalityStage mille ollaan modaalisia, null = sovellukselle
     * @param oletus mitä nimeä näytetään oletuksena
     * @return null jos painetaan cancel, muuten nimi
     */
    public static String kysyNimi(Stage modalityStage, String oletus) {
        return ModalController.showModal(
                LoginController.class.getResource("LoginView.fxml"), "Kirjaudu", modalityStage, oletus
        );
    }

    @Override
    public String getResult() {
        return email;
    }

    @Override
    public void setDefault(String s) {

    }

    @Override
    public void handleShown() {

    }
}
