package fxPadelRekisteri;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.TextAreaOutputStream;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.TextArea;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.BorderPane;
import javafx.scene.text.Font;
import padelRekisteri.Kayttaja;
import padelRekisteri.Tulos;

import java.io.PrintStream;
import java.net.URL;
import java.util.ResourceBundle;

/**
 * @author joonas
 * @version 04/02/2025
 */
public class PadelRekisteriGUIController extends ViewChangeHandler implements Initializable {

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        if (kayttaja != null) {
            alusta();
        }
    }

    @FXML
    void handleUusiTulos(MouseEvent event) {
        UusiTulosController.avaaUusiTulos();
        if (true) {
            Tulos t2 = new Tulos();
            t2.asetaTestiArvot("5-6", "6-4", "4-6");
            kayttaja.lisaaTulos(t2);
            hae(t2.getId());
        }
    }

    @FXML
    void handleTallenna(MouseEvent event) {
        Dialogs.showMessageDialog("Ei osata tallentaa");
    }

    @FXML
    void handleJarjesta() {
        Dialogs.showMessageDialog("Ei osata jarjestaa");
    }

    @FXML
    private BorderPane panelTulos;
    @FXML
    private ListChooser<Tulos> chooserTulokset;

    private Kayttaja kayttaja;
    private Tulos valittuTulos;
    private TextArea areaTulos = new TextArea();

    /**
     * @return false jos painetaan cancel, muuten true
     */
    public boolean avaa() {
        String uusinimi = LoginController.kysyNimi(null, "testi");
        if (uusinimi == null) {
            return false;
        }
        //lueTiedosto(uusinimi)
        return true;
    }

    public void setKayttaja(Kayttaja kayttaja) {
        this.kayttaja = kayttaja;
    }

    public Kayttaja getKayttaja() {
        return kayttaja;
    }

    /**
     * Tekee tarvittavat muut alustukset, nyt vaihdetaan GridPanen tilalle
     * yksi iso tekstikenttä, johon voidaan tulostaa jäsenten tiedot.
     * Alustetaan myös jäsenlistan kuuntelija
     */
    public void alusta() {
        panelTulos.setCenter(areaTulos);
        areaTulos.setFont(new Font("Courier New", 12));

        chooserTulokset.clear();
        chooserTulokset.addSelectionListener(e -> naytaTulos());
        haeTulokset();
    }

    /**
     * Näyttää valitun hallin tiedot
     */
    protected void naytaTulos() {
        valittuTulos = chooserTulokset.getSelectedObject();
        if (valittuTulos == null) return;

        areaTulos.setText("");
        try (PrintStream os = TextAreaOutputStream.getTextPrintStream(areaTulos)) {
            valittuTulos.tulosta(os);
        }
    }

    /**
     * hakee tulokset ja asettaa ne listchooseriin
     */
    protected void haeTulokset() {
        kayttaja.getTulokset().iterator().forEachRemaining(tulos -> {
            chooserTulokset.add(tulos.getTulokset(), tulos);
        });
    }

    /**
     * Hakee jäsenten tiedot listaan
     */
    protected void hae(int id) {
        chooserTulokset.clear();
        int index = 0;
        for (int i = 0; i < kayttaja.getTulokset().getTulokset().size(); i++) {
            Tulos t = kayttaja.getTulokset().etsi(id);
            if (t != null) {
                if (t.getId() == id) {
                    index = i;
                }
                chooserTulokset.add(t.getTulokset(), t);
            }
        }
        chooserTulokset.setSelectedIndex(index); // tästä tulee muutosviesti joka näyttää jäsenen
    }

}