package padelRekisteri;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Random;

public class Kayttaja implements Luettava<Kayttaja> {
    private int id;
    private String nimi = "";
    private String email = "";
    private String puhelinnumero = "";
    private String osoite = "";
    private int postinumero;
    private String postitoimipaikka = "";
    private int syntymavuosi = 0;
    private String sukupuoli = "";
    private static int seuraavaId = 1;


    private Hallit hallit = new Hallit();
    private Tulokset tulokset = new Tulokset();

    public void asetaTestiArvot() {
        Random rand = new Random();
        nimi = "Jaskan Jokunen " + rand.nextInt(1000, 9999);
        email = "jaska@gmail.com" + rand.nextInt(1000, 9999);
        puhelinnumero = "123-123-123";
        osoite = "Jaskankuja " + rand.nextInt(1000, 9999);
        postinumero = 20540;
        postitoimipaikka = "Turku";
        syntymavuosi = 2025;
        sukupuoli = "Mies";
        rekisteroi();
    }

    /**
     * Tulostetaan henkilön tiedot
     * @param out tietovirta johon tulostetaan
     */
    public void tulosta(PrintStream out) {
        out.println(String.format("%03d", id, 3) + "  " + nimi);
        out.println(" Email: " + email + ".");
        out.println(" PuhNum: " + puhelinnumero + ".");
        out.println("  " + osoite + "  " + postinumero + " " + postitoimipaikka);
        out.print(" Syntynyt: " + syntymavuosi + ".");
        out.print(" Aukioloaika: " + sukupuoli + ".");
    }


    /**
     * Antaa hallille uuden id:n
     * @return uusi id
     */
    public int rekisteroi() {
        id = seuraavaId;
        seuraavaId++;
        return id;
    }

    /**
     * lisää halli käyttäjän tietoihin
     */
    public void lisaaHalli(Halli halli) {
        hallit.lisaa(halli);
    }

    /**
     * Lisaa tuloksen käyttäjän tietoihin
     */
    public void lisaaTulos(Tulos tulos) {
        tulokset.lisaa(tulos);
    }

    public Hallit getHallit() {
        return hallit;
    }
    public Tulokset getTulokset() {
        return tulokset;
    }

    public String getNimi() {
        return nimi;
    }

    /**
     * Etsii käyttäjän tiedot idn kanssa
     * @param id kayttajan id
     * @return käyttäjän tiedot jos löytyy
     */
    public Kayttaja etsi(int id) {
        ArrayList<Kayttaja> kayttajat = lueTiedostosta();
        for (Kayttaja kayttaja : kayttajat) {
            if (kayttaja.id == id) {
                return kayttaja;
            }
        }
        return null;
    }

    /**
     * Lue tiedostosta
     */
    public ArrayList<Kayttaja> lueTiedostosta() {
        ArrayList<Kayttaja> kayttajat = new ArrayList<>();
        return kayttajat;
    }
}
