package padelRekisteri;

import fxPadelRekisteri.PadelRekisteriGUIController;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Calendar;

public class Tulos {
    private int id;
    private int halli_id;
    private String pvm = String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
    private String era1;
    private String era2;
    private String era3;
    private int pelaajaKotiVasen;
    private int pelaajaKotiOikea;
    private int pelaajaVierasVasen;
    private int pelaajaVierasOikea;

    private static int seuraavaId = 1;

    /**
     * Tulostetaan tuloksen
     * @param out tietovirta johon tulostetaan
     */
    public void tulosta(PrintStream out) {
        Halli h = etsiHalli();
        if (h != null) {
            out.println(String.format("%03d", id, 3) + " " + pvm + "  " + h.getNimi());
        } else {
            out.println(String.format("%03d", id, 3) + " " + pvm );
        }
        out.println(getTulokset());
        tulostaPelaajat(out);
    }

    public void tulostaPelaajat(PrintStream out) {
        out.println("Pelaajat:");
        for (Kayttaja k : etsiPelaajat()) {
            if (k != null) {
                out.println(k.getNimi());
            }
        }
    }

    public void asetaTestiArvot() {
        asetaTestiArvot("", "",  "");
    }
    public void asetaTestiArvot(String e1, String e2, String e3) {
        halli_id = 1;
        era1 = e1.isEmpty() ? e1 : "6-1";
        era2 = e2.isEmpty() ? e2: "4-6";
        era3 = e3.isEmpty() ? e3 : "6-3";
        pelaajaKotiVasen = 1;
        pelaajaKotiOikea = 1;
        pelaajaVierasVasen = 1;
        pelaajaVierasOikea = 1;
        rekisteroi();
    }

    public int rekisteroi() {
        id = seuraavaId;
        seuraavaId++;
        return id;
    }

    public int getId() {
        return id;
    }

    public String getTulokset() {
        return " Tulokset : erä 1 - " + era1 + " erä 2 - " + era2 + " erä 3 - " + era3;
    }

    /**
     * Etsii tulokselle kuuluvan hallin
     * @return
     */
    private Halli etsiHalli() {
        Hallit h = new Hallit();
        Halli halli = h.etsi(id);
        return halli;
    }

    private ArrayList<Kayttaja> etsiPelaajat() {
        ArrayList<Kayttaja> pelaajat = new ArrayList<>();
        Kayttaja k = new Kayttaja();
        if (pelaajaKotiVasen > 0) {
            pelaajat.add(k.etsi(pelaajaKotiVasen));
        }
        if (pelaajaKotiOikea > 0) {
            pelaajat.add(k.etsi(pelaajaKotiOikea));
        }
        if (pelaajaVierasVasen > 0) {
            pelaajat.add(k.etsi(pelaajaVierasVasen));
        }
        if (pelaajaVierasOikea > 0) {
            pelaajat.add(k.etsi(pelaajaVierasOikea));
        }
        return pelaajat;
    };
}
