public class Algoritmi {

    /**
     * Laskee kokonaisluku taulukon keskiarvon, niin että pienintä ja suurinta alkiota ei huomioida.
     *
     * @return keskiarvo, jos keskiarvoa ei voida laskea palautetaan 0
     * @example <pre name="test">
     * int[] t = {0,1};
     * keskiarvo(t) === 0
     * int[] t2 = {0,1,2,3,5};
     * keskiarvo(t2) === 2
     * int[] t3 = { 11, 11, 11, 11, 11};
     * keskiarvo(t3) === 11
     * int[] t4 = { -5, 11, 11, 11, 11};
     * keskiarvo(t4) === 11
     * </pre>
     */
    public static int keskiarvo(int[] taulukko) {
        if (taulukko.length < 3) {
            return 0;
        }
        // alustetaan pienin hyvin suureksi ja suurin arvo hyvin pieneksi
        int pieninIndeksi = 0;
        int suurinIndeksi = 0;
        int summa = 0;
        for (int i = 0; i < taulukko.length; i++) {
            if (taulukko[i] < taulukko[pieninIndeksi]) {
                pieninIndeksi = i;
            }
            if (taulukko[i] > taulukko[suurinIndeksi]) {
                suurinIndeksi = i;
            }
            summa += taulukko[i];
        }
        //otetaan pienin ja suurin pois
        summa -= taulukko[pieninIndeksi];
        summa -= taulukko[suurinIndeksi];

        return summa / (taulukko.length - 2);
    }

    public static void main(String[] args) {
        int[] t4 = {-5, 11, 11, 11, 11};
        if (keskiarvo(t4) == 11) {
            System.out.println("toimii");
        }
        ;
    }
}
