
public class Joukkue {

    private Pelaaja[] pelaajat = new Pelaaja[3];
    private int lkm = 0;


    /**
     * Lisää annetun pelaajan joukkueeseen.
     * @param pelaaja Lisättävä pelaaja.
     */
    public void lisaaPelaaja(Pelaaja pelaaja) {
        // jos taulukko täys, kasvatetaan kokoa yhdellä
        if (lkm == pelaajat.length) {
            Pelaaja[] t = new Pelaaja[lkm + 1];
            for (int i = 0; i < pelaajat.length; i++) {
                t[i] = pelaajat[i];
            }
            pelaajat = t;
        }
        pelaajat[lkm] = pelaaja;
        lkm++;
    }

    /**
     * Tulostaa pelaajat pareittain formaatissa:
     * Matti (0) - Keinane (185)
     * Mikko (178) - Irmeli (198)
     * Jape (181)
     */
    public void tulostaPareittain() {
        for (int i = 0; i < pelaajat.length; i++) {
            Pelaaja p = pelaajat[i];
            StringBuilder sb = new StringBuilder(p.toString());
            if (pelaajat.length > i + 1) {
                sb.append(" - ").append(p.toString());
            }
            i++;
            System.out.println(sb);
        }
    }

    /**
     * @return Palauttaa joukkueen pelaajan, jolla eniten pisteitä
     */
    public Pelaaja parasPelaaja(){
        Pelaaja pel = pelaajat[0];
        for (Pelaaja p: pelaajat) {
            if (pel.getPisteet() < p.getPisteet()) {
                pel = p;
            }
        };
        return pel;
    }

    /**
     * Pääohjelma testaa Joukkue- ja Pelaaja-luokkaa.
     * @param args Ei käytössä.
     */
    public static void main(String[] args) {

        Pelaaja matti = new Pelaaja("Matti");

        // a) 1p - Pelaajan merkkijonoesitys on muotoa: nimi (pisteet)
        System.out.println(matti);
        // Tulostus: Matti (0)

        Pelaaja keinane = new Pelaaja("Keinane", 185);
        Pelaaja mikko = new Pelaaja("Mikko", 178);
        Pelaaja jape = new Pelaaja("Jape", 181);
        Pelaaja irmeli = new Pelaaja("Irmeli", 198);

        Joukkue joukkue = new Joukkue();
        joukkue.lisaaPelaaja(matti);
        joukkue.lisaaPelaaja(keinane);
        joukkue.lisaaPelaaja(mikko);
        joukkue.lisaaPelaaja(irmeli);

        // b) 1p - Muuta Joukkue-luokan lisaaPelaaja-metodia siten,
        // että taulukon koko kasvaa dynaamisesti, ts. taulukko osaa kasvattaa
        // itseään, jos sinne yritetään lisätä enemmän alkioita, kuin mitä siihen mahtuu.

        joukkue.lisaaPelaaja(jape);

        //  c) 2p - Tulostaa pelaajat pareittain, niin että yksi
        // pelaaja kuuluu vain yhteen pariin siten, että ensimmäiset kaksi
        //  tulostuvat keskenään, seuraavat kaksi keskenään jne.
        joukkue.tulostaPareittain();
        // Tulostus:
        // Matti (0) - Keinane (185)
        // Mikko (178) - Irmeli (198)
        // Jape (181)

        // d) 2p - paras pelaaja on se pelaaja, jolla on eniten pisteitä.
        // Täydennä myös Pelaaja-luokkaan vaaditut muutokset
        if (joukkue.parasPelaaja() != null) {
            System.out.println("Paras pelaaja on " + joukkue.parasPelaaja());
            // Tulostus: Paras pelaaja on Irmeli (198)
        }
    }
}
