public class Peruna extends Juures {
    private String lajike;

    public Peruna(int kcal,String lajike) {
        super("Peruna", kcal);
        this.lajike = lajike;
    }

    /**
     * Vaihtaa perunan lajikkeen
     * @param uusiLajike uusi lajike
     * @param kcal uuden lajin kcal
     * @example <pre name="test">
     * Peruna peruna = new Peruna(35, "Timo");
     * peruna.annaTiedot() === "Juureksen nimi: Peruna. Kcal per gramma: 35. Perunalajike: Timo"
     * peruna.vaihdaLajike("Siikli", 50);
     * peruna.annaTiedot() === "Juureksen nimi: Peruna. Kcal per gramma: 50. Perunalajike: Siikli"
     * </pre>
     */
    public void vaihdaLajike(String uusiLajike, int kcal) {
        this.lajike = uusiLajike;
        this.setKcal(kcal);
    }

    @Override
    public String annaTiedot() {
        return super.annaTiedot() + ". Perunalajike: " + this.lajike;
    }
}
